package com.bbc.denadrive

import androidx.compose.runtime.Composable
import androidx.navigation.NavHostController
import androidx.navigation.compose.NavHost
import androidx.navigation.compose.composable
import com.bbc.denadrive.home.DetailsScreen
import com.bbc.denadrive.home.HomeScreen
import com.bbc.denadrive.home.ScaffoldWithSidebar
import androidx.compose.material3.Text
import com.bbc.denadrive.home.MyListVisualizer

@Composable
fun NavigationGraph(navController: NavHostController) {
    // Create a NavHost that defines the navigation graph
    NavHost(navController = navController, startDestination = "prova") {
        // Define the home screen destination
        composable("home") { HomeScreen(navController) }

        // Define the details screen destination with an argument
        composable("details/{itemId}") { backStackEntry ->
            // Retrieve the argument from the back stack entry
            val itemId = backStackEntry.arguments?.getString("itemId")
            // Pass the argument to the DetailsScreen
            DetailsScreen(itemId, navController)
        }

        composable("prova") { ScaffoldWithSidebar { lista -> MyListVisualizer(lista) } }
    }
}
