package com.bbc.denadrive.home

import androidx.compose.animation.core.animateFloatAsState
import androidx.compose.foundation.background
import androidx.compose.material3.Button
import androidx.compose.material3.Text
import androidx.compose.runtime.Composable
import androidx.navigation.NavHostController
//import androidx.compose.foundation.background
//import androidx.compose.foundation.clickable
//import androidx.compose.foundation.layout.*
//import androidx.compose.material3.*
//import androidx.compose.runtime.*
//import androidx.compose.ui.Alignment
//import androidx.compose.ui.Modifier
//import androidx.compose.ui.graphics.Color
//import androidx.compose.ui.unit.dp
//import androidx.compose.ui.unit.sp

import androidx.compose.foundation.clickable
import androidx.compose.foundation.gestures.detectTapGestures
import androidx.compose.foundation.layout.*
import androidx.compose.foundation.lazy.LazyColumn
import androidx.compose.material.icons.Icons
import androidx.compose.material.icons.filled.Menu
import androidx.compose.material.icons.filled.MoreVert
import androidx.compose.material3.*
import androidx.compose.runtime.*
import androidx.compose.ui.Alignment
import androidx.compose.ui.Modifier
import androidx.compose.ui.draw.scale
import androidx.compose.ui.graphics.Color
import androidx.compose.ui.input.pointer.pointerInput
import androidx.compose.ui.unit.dp
import androidx.compose.ui.unit.sp
import kotlinx.coroutines.launch
import androidx.compose.foundation.lazy.items

//import androidx.compose.material3.icons.Icons
//import androidx.compose.material3.icons.filled.Menu
//import androidx.compose.material3.icons.filled.MoreVert

@Composable
fun HomeScreen(navController: NavHostController) {
    Button(onClick = { navController.navigate("details/1") }) {
        Text("Go to Details")
    }
}

@Composable
fun DetailsScreen(itemId: String?, navController: NavHostController) {
    Text(text = "Details for item: $itemId")
}


@OptIn(ExperimentalMaterial3Api::class)
@Composable
fun ScaffoldWithSidebar(
    toBeDisplayed: @Composable (List<String>) -> Unit
) {
    // State to control the drawer
    val drawerState = rememberDrawerState(initialValue = DrawerValue.Closed)
    val scope = rememberCoroutineScope()

    val lista = listOf<String>("a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z",)

    // ModalNavigationDrawer
    ModalNavigationDrawer(
        drawerState = drawerState,
        drawerContent = {
            // Drawer content
            Column(
                modifier = Modifier
                    .fillMaxHeight()
                    .fillMaxWidth(0.67f)
                    .background(Color.White)
            ) {
                RectangularButton(backgroundColor = Color.White, text = "Text 1") {  }
//                Spacer(modifier = Modifier.height(10.dp))
                RectangularButton(backgroundColor = Color.White, text = "Text 2") {  }
//                Spacer(modifier = Modifier.height(10.dp))
                RectangularButton(backgroundColor = Color.White, text = "Text 3") {  }
            }
        },
        content = {
            // Main content of the screen
            Scaffold(
                topBar = {
                    TopAppBar(
                        title = { Text("My App") },
                        navigationIcon = {
                            IconButton(onClick = {
                                scope.launch {
                                    drawerState.open()
                                }
                            }) {
                                // Icon for the menu (three horizontal lines)
                                Icon(Icons.Filled.Menu, contentDescription = "Menu")
                            }
                        },
                        actions = {
                            IconButton(onClick = { /* Handle settings click */ }) {
                                // Icon for the settings (three vertical dots)
                                Icon(Icons.Filled.MoreVert, contentDescription = "Settings")
                            }
                        }
                    )
                },
                content = { innerPadding ->
                    Box(
                        modifier = Modifier
                            .fillMaxSize()
                            .padding(innerPadding)
                            .padding(16.dp),
                        contentAlignment = Alignment.Center
                    ) {
                        toBeDisplayed(lista)
//                        Text("Main Content", fontSize = 24.sp)
                    }
                }
            )
        }
    )
}

@Composable
fun RectangularButton(
    backgroundColor: Color,
    text: String,
    onClick: () -> Unit
) {
    var isPressed by remember { mutableStateOf(false) }
    val scale by animateFloatAsState(if (isPressed) 0.8f else 1f)

    Box(
        modifier = Modifier
            .fillMaxWidth()
            .height(48.dp) // Set the height of the button
            .background(color = backgroundColor) // Set the background color
            .scale(scale) // Apply the scale effect
            .pointerInput(Unit) {
                // Detect press and release gestures
                detectTapGestures(
                    onPress = {
                        isPressed = true
                        // Wait for the click to be released
                        tryAwaitRelease()
                        isPressed = false
                    },
                    onTap = { onClick() } // Call the onClick action
                )
            }
            .padding(8.dp),
        contentAlignment = Alignment.Center // Center the text
    ) {
        Text(text = text, style = MaterialTheme.typography.bodyLarge) // Button text
    }
}

@Composable
fun MyListVisualizer (
    lista: List<String>
) {
    LazyColumn {
        items(lista) { messaggio -> Text(text=messaggio, fontSize = 30.sp) }
    }
}

//@Composable
//fun MyApp() {
//    ScaffoldWithSidebar()
//}

//@Composable
//fun MainActivityContent() {
//    MyApp()
//}


//@OptIn(ExperimentalMaterial3Api::class)
//@Composable
//fun ScaffoldWithSidebar() {
//    // State to control the drawer
//    var isDrawerOpen by remember { mutableStateOf(false) }
//
//    // Main Scaffold
//    Scaffold(
//        topBar = {
//            TopAppBar(
//                title = { Text("My App") },
//                navigationIcon = {
//                    IconButton(onClick = { isDrawerOpen = true }) {
//                        // Icon for the menu (three horizontal lines)
//                        Icon(Icons.Filled.Menu, contentDescription = "Menu")
//                    }
//                },
//                actions = {
//                    IconButton(onClick = { /* Handle settings click */ }) {
//                        // Icon for the settings (three vertical dots)
//                        Icon(Icons.Filled.MoreVert, contentDescription = "Settings")
//                    }
//                }
//            )
//        },
//        drawerContent = {
//            // Drawer content
//            Column(
//                modifier = Modifier
//                    .fillMaxSize()
//                    .padding(16.dp)
//            ) {
//                Text("Item 1", modifier = Modifier.clickable { /* Handle click */ })
//                Spacer(modifier = Modifier.height(8.dp))
//                Text("Item 2", modifier = Modifier.clickable { /* Handle click */ })
//                Spacer(modifier = Modifier.height(8.dp))
//                Text("Item 3", modifier = Modifier.clickable { /* Handle click */ })
//            }
//        },
//        drawerGesturesEnabled = true,
//        drawerShape = MaterialTheme.shapes.large,
//        drawerContentColor = MaterialTheme.colorScheme.background,
//        drawerContainerColor = MaterialTheme.colorScheme.surface,
//        content = { padding ->
//            // Main content of the screen
//            Box(
//                modifier = Modifier
//                    .fillMaxSize()
//                    .padding(padding)
//                    .background(Color.White),
//                contentAlignment = Alignment.Center
//            ) {
//                Text("Main Content", fontSize = 24.sp)
//            }
//        }
//    )
//
//    // Handle drawer state
//    if (isDrawerOpen) {
//        // Close the drawer when clicking outside
//        Box(
//            modifier = Modifier
//                .fillMaxSize()
//                .background(Color.Black.copy(alpha = 0.5f))
//                .clickable { isDrawerOpen = false }
//        )
//    }
//}
